unit uexmpl;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBCtrls, StdCtrls, Mask, DBTables, Grids, DBGrids, ExtCtrls, ComCtrls,
  DB, Menus;

type
  TExampleMain = class(TForm)
    StatusBar1                 : TStatusBar;
    DBGrid1                    : TDBGrid;
    Panel1                     : TPanel;
    Label2                     : TLabel;
    DBEdit2                    : TDBEdit;
    Label3                     : TLabel;
    DBEdit3                    : TDBEdit;
    Label4                     : TLabel;
    DBEdit4                    : TDBEdit;
    Label5                     : TLabel;
    DBEdit5                    : TDBEdit;
    Label7                     : TLabel;
    DBEdit7                    : TDBEdit;
    Label6                     : TLabel;
    DBEdit6                    : TDBEdit;
    Panel2                     : TPanel;
    DBNavigator1               : TDBNavigator;
    Memo1                      : TMemo;
    DBEdit1                    : TDBEdit;
    Label1                     : TLabel;

    MainMenu1                  : TMainMenu;
    File1                      : TMenuItem;
    Exit1                      : TMenuItem;
    Report1                    : TMenuItem;
    SingleOrder1               : TMenuItem;
    Allorders1                 : TMenuItem;

    tblCustomer                : TTable;
    dsCustomer                 : TDataSource;
    tblCustomerCustNo          : TFloatField;
    tblCustomerCompany         : TStringField;
    tblCustomerAddr1           : TStringField;
    tblCustomerAddr2           : TStringField;
    tblCustomerCity            : TStringField;
    tblCustomerState           : TStringField;
    tblCustomerZip             : TStringField;
    tblCustomerCountry         : TStringField;
    tblCustomerPhone           : TStringField;
    tblCustomerFAX             : TStringField;
    tblCustomerTaxRate         : TFloatField;
    tblCustomerContact         : TStringField;
    tblCustomerLastInvoiceDate : TDateTimeField;

    tblOrders                  : TTable;
    dsOrders                   : TDataSource;
    tblOrdersOrderNo           : TFloatField;
    tblOrdersCustNo            : TFloatField;
    tblOrdersSaleDate          : TDateTimeField;
    tblOrdersShipDate          : TDateTimeField;
    tblOrdersEmpNo             : TIntegerField;
    tblOrdersShipToContact     : TStringField;
    tblOrdersShipToAddr1       : TStringField;
    tblOrdersShipToAddr2       : TStringField;
    tblOrdersShipToCity        : TStringField;
    tblOrdersShipToState       : TStringField;
    tblOrdersShipToZip         : TStringField;
    tblOrdersShipToCountry     : TStringField;
    tblOrdersShipToPhone       : TStringField;
    tblOrdersShipVIA           : TStringField;
    tblOrdersPO                : TStringField;
    tblOrdersTerms             : TStringField;
    tblOrdersPaymentMethod     : TStringField;
    tblOrdersItemsTotal        : TCurrencyField;
    tblOrdersTaxRate           : TFloatField;
    tblOrdersFreight           : TCurrencyField;
    tblOrdersAmountPaid        : TCurrencyField;
    Allwith2Columns1: TMenuItem;

    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Exit1Click(Sender: TObject);
    procedure SingleOrder1Click(Sender: TObject);
    procedure Allorders1Click(Sender: TObject);
    procedure Allwith2Columns1Click(Sender: TObject);
  private
    { Private-Deklarationen }
    Procedure PrintAll (allOrder:string);
  public
    { Public-Deklarationen }
  end;

var
  ExampleMain: TExampleMain;

implementation
uses
  alrep, alprev, upreview;
{$R *.DFM}

procedure TExampleMain.FormCreate(Sender: TObject);
begin
  tblCustomer.Open;
  tblOrders.Open;
end;

procedure TExampleMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  tblCustomer.Close;
  tblOrders.Close;
end;

procedure TExampleMain.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TExampleMain.SingleOrder1Click(Sender: TObject);
var
  sglOrder : string;
  rep      : tAlReport;
  frm      : tForm;
  Total    : extended;
begin
  // orderlist for single customer

  // Build the filename for the report form.
  sglOrder := ExtractFilePath (Application.ExeName)+'sglOrder.dfm';

  // Note: the report forms should not be added to the project file.
  //   instead you can place them in a forms-subdirectory of your
  //   software. You can then easily select different forms for
  //   the same report-process, to customize the layout.

  // now try to load the report.
  // rep gives back the tAlReport object of the form.
  //    hereby you have access to the report to add variables.
  // frm is the form loaded. This is what you have to release
  //    after printing/previewing.
  //    see cleanup...
  if LoadReport (sglOrder,rep,frm) then
   begin
     rep.AddNamedValue ('CustNo',  IntToStr(Round(tblCustomerCustNo.value)));
     rep.AddNamedValue ('Company', tblCustomerCompany.value);
     rep.AddNamedValue ('Addr1',   tblCustomerAddr1.value);
     rep.AddNamedValue ('Addr2',   tblCustomerAddr2.value);
     rep.AddNamedValue ('City',    tblCustomerCity.value);
     rep.AddNamedValue ('State',   tblCustomerState.value);
     rep.AddNamedValue ('Zip',     tblCustomerZip.value);
     rep.AddNamedValue ('Country', tblCustomerCountry.value);
     rep.AddNamedValue ('Phone',   tblCustomerPhone.value);
     rep.AddNamedValue ('Fax',     tblCustomerFAX.value);
     rep.AddNamedValue ('TaxRate', Format('%n',[tblCustomerTaxRate.value]));
     rep.AddNamedValue ('Contact', tblCustomerContact.value);
     rep.AddNamedValue ('LastInvoiceDate',tblCustomerLastInvoiceDate.AsString);
     tblOrders.First;
     Total := 0;
     while NOT tblOrders.Eof do
      begin
        rep.AddNamedValue ('OrderNo',       IntToStr(Round(tblOrdersOrderNo.value)));
        rep.AddNamedValue ('SaleDate',      tblOrdersSaleDate.AsString);
        rep.AddNamedValue ('ShipDate',      tblOrdersShipDate.AsString);
        rep.AddNamedValue ('EmpNo',         IntToStr(tblOrdersEmpNo.value));
        rep.AddNamedValue ('PaymentMethod', tblOrdersPaymentMethod.value);
        rep.AddNamedValue ('ItemsTotal',    Format('%n',[tblOrdersItemsTotal.value]));
        rep.AddNamedValue ('Freight',       Format('%n',[tblOrdersFreight.value]));
        rep.AddNamedValue ('AmountPaid',    Format('%n',[tblOrdersAmountPaid.value]));
        Total := Total + tblOrdersItemsTotal.value;
        tblOrders.Next;
      end;
     rep.AddNamedValue ('TotalTotal', Format('%n',[Total]));
     rep.AddNamedValue ('LONGTEXT',Memo1.Text);

     // preview or print
     // ----------------

     // This is for the preview
     with tFrmPreview.Create(Application) do
      begin
        rep.Preview (Previewer.FPages);
        FirstPage;
      end;

     // if you want direct printing instead of previewing
     // just change the previous lines to

     // rep.Print

     // cleanup
     // -------
     frm.Release;
   end
  else
     MessageDlg (Format('could not load report %s',[sglOrder]),
                 mtError,[mbOK],0);
end;

procedure TExampleMain.PrintAll (allOrder:string);
var
  rep        : tAlReport;
  frm        : tForm;
  Total      : extended;
  GrandTotal : extended;
begin
  if LoadReport (allOrder,rep,frm) then
   begin
     GrandTotal := 0;
     tblCustomer.First;
     while NOT tblCustomer.Eof do
      begin
        tblOrders.First;
        Total := 0;
        while NOT tblOrders.Eof do
         begin
           // All fields that appear in the DetailLink Bands
           //   GroupHeader, GroupFooter, GroupBand
           // Must appear as Details in the Data List.
           // Also they must appear in the Detail Band as originally
           //    named values e.g. "CustNo".
           //    You set their visible-property to false, if they
           //    should not be printed.
           // When printed in the GroupHeader/GroupFooter you add them
           //    as copied values e.g. "CustNo_".

           // Group Header/Footer values
           rep.AddNamedValue ('CustNo',  IntToStr(Round(tblCustomerCustNo.value)));
           rep.AddNamedValue ('Company', tblCustomerCompany.value);
           rep.AddNamedValue ('LastInvoiceDate',tblCustomerLastInvoiceDate.AsString);
           // Detail values
           rep.AddNamedValue ('OrderNo',    IntToStr(Round(tblOrdersOrderNo.value)));
           rep.AddNamedValue ('SaleDate',   tblOrdersSaleDate.AsString);
           rep.AddNamedValue ('ShipDate',      tblOrdersShipDate.AsString);
           rep.AddNamedValue ('EmpNo',         IntToStr(tblOrdersEmpNo.value));
           rep.AddNamedValue ('PaymentMethod', tblOrdersPaymentMethod.value);
           rep.AddNamedValue ('ItemsTotal', Format('%n',[tblOrdersItemsTotal.value]));
           // calculate the total
           Total := Total + tblOrdersItemsTotal.value;
           // Group Header/Footer values
           // Note: this can be a calculated value, so we add it
           // after the static values, because normally you do
           // calculation after data-retrieval.
           rep.AddNamedValue ('CustomerTotal', Format('%n',[Total]));

           tblOrders.Next;
         end;
        // calculate the GrandTotal.
        GrandTotal := GrandTotal + Total;
        tblCustomer.Next;
      end;
     // Now add the GrandTotal to the report. It's just a single value
     // printed in the report-footer.
     rep.AddNamedValue ('GrandTotal', Format('%n',[GrandTotal]));

     // preview or print
     with tFrmPreview.Create(Application) do
      begin
        rep.Preview (Previewer.FPages);
        FirstPage;
      end;
     // cleanup
     frm.Release;
   end
  else
     MessageDlg (Format('could not load report %s',[allOrder]),
                 mtError,[mbOK],0);
end;

procedure TExampleMain.Allorders1Click(Sender: TObject);
var
  allOrder : string;
begin
  allOrder := ExtractFilePath (Application.ExeName)+'allOrder.dfm';
  PrintAll (allOrder);
end;

procedure TExampleMain.Allwith2Columns1Click(Sender: TObject);
var
  allOrder : string;
begin
  allOrder := ExtractFilePath (Application.ExeName)+'colOrder.dfm';
  PrintAll (allOrder);
end;

end.
